import { View, Text, Input } from "@tarojs/components"
import Taro, { useDidShow } from "@tarojs/taro"
import { Button, Form, FormItem, Icon } from "@antmjs/vantui";

import { useEffect, useState } from "react";
import { useModel } from "../../store";
import { getPhoneuser, setUserInfo } from "../../services/user";
// import BottomMoadl from '@/components/BottomMoadl/index'
import './style.less'

let form = null

export default (props) => {
  const [phone, setPhone] = useState('18052044111')

  const { deptName, person, sessionKey, setPerson, formValue } = useModel('userData')
  console.log('formValue', formValue);

  const onSubmit = (e) => {
    form.validateFields((errorMessage, fieldValues) => {
      if (errorMessage && errorMessage.length) {
        console.info('fieldValues', fieldValues)

        return console.info('errorMessage', errorMessage)
      } else {
        console.info('fieldValues', fieldValues)
        // setFormValue(fieldValues)
        // Taro.redirectTo({
        //   url: '/pages/index/index'
        // })
        setUserInfo({ ...fieldValues, person: person?.personId, deptCode: deptName?.id }).then((e) => {
          // setFormValue(fieldValues)
          setPerson(e);
          Taro.showToast({
            title: '保存成功',
            icon: 'none',
            duration: 2000
          }).then(() => {
            Taro.redirectTo({
              url: '/pages/index/index'
            })
          })

        })

      }
    })
  }

  const goDepartmen = () => {
    Taro.navigateTo({
      url: '/pages/DepartmentSelection/index'
    })

  }
  useDidShow(() => {


  }, [deptName])

  useEffect(() => {
    if (person) {
      form.setFields(person)

    }
    console.log('deptName', deptName);
    if (deptName) {
      form.setFieldsValue('deptName', deptName?.name)

      // form.setFieldsValue({ name: 'deptName', modelValue: deptName?.deptName })

    }
  }, [deptName, person])


  const getPhone = (e) => {
    console.log('deptName', deptName);
    console.log('手机号', e);
    const { errMsg, ...data } = e.detail || {}

    getPhoneuser({ ...data, sessionKey: sessionKey }).then((res) => {
      setPhone(res?.phoneNumber)
      console.log('form', form);
      form.setFieldsValue('phone', res?.phoneNumber)
      // form.setFieldsValue({ phone: res.phoneNumber })
      // setFormValue({ phone: res?.phoneNumber })
    })

  }
  return (
    <View className='page-index'>
      <Form
        ref={(el) => (form = el)}
        onFinish={(e) => onSubmit(e)}
      >
        <FormItem
          label='用户名'
          name='personName'
          required
          trigger='onInput'
          validateTrigger='onBlur'
          valueFormat={(e) => e.detail.value}
        >
          <Input placeholder='请输入用户名' />
        </FormItem>
        <FormItem
          label='手机号'
          name='phone'
          trigger='onInput'
          required
          validateTrigger='onBlur'
          valueFormat={(e) => e.detail.value}
          renderRight={<Button
            plain
            hairline
            size='small'
            type='info'
            required
            openType='getPhoneNumber'
            onGetPhoneNumber={getPhone}
          >
            授权手机
          </Button>}
        >
          <Input placeholder='请输入手机号' maxlength={11} disabled />


        </FormItem>

        <FormItem
          label='身份证'
          name='idNo'
          required
          trigger='onInput'
          validateTrigger='onBlur'
          valueFormat={(e) => e.detail.value}
        >
          <Input placeholder='请输入身份证号' type='number' maxlength={18} />
        </FormItem>

        <FormItem
          label='科室'
          name='deptName'
          trigger='onInput'
          required
          validateTrigger='onBlur'
          valueFormat={(e) => e.detail.value}
        >
          <Input placeholder='请选择科室' onClick={goDepartmen} disabled />
        </FormItem>
        <View className='buttom-box'>
          <Button
            type='info'
            size='normal'
            formType='submit'
            className='buttom-box-buttonSubmit'
          >
            提交
          </Button>
        </View>

      </Form>
    </View>
  )
}
